//  This file is part of foo_timedisplay.
//
//  foo_timedisplay is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  foo_timedisplay is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with foo_timedisplay. If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include "foobar2000.h"
#include "helpers.h"

#include "helper.h"

#define PLUGINNAME "Time Display"

#define MAXTIMESTRINGLENGTH 25
#define MAXDISPLAYSTRINGLENGTH 500
#define MAXFONTWIDTH 300
#define DEFAULTHORIZONTALPADDING 25
#define ALIGN_LEFT 0
#define ALIGN_RIGHT 1
#define ALIGN_CENTER 2

#define TIMEFIELD "%time%"
#define TIMEFIELDCOMMAND "time"

struct t_sFont
{
	WCHAR szName[32];
	DWORD dwWeight;
	BYTE bItalic;
	COLORREF cfColor;
	COLORREF cfBackColor;
	COLORREF cfaCustColors[16];
};

class foo_timedisplay
{
public:
	foo_timedisplay();
	~foo_timedisplay();

	static void updateRemainingPlaylistLength(void);
	static void ProcessDisplayFormatString( static_api_ptr_t<playback_control> pPlaybackControl );
	static void UpdateDisplayString();
	static void ResetScrollPos();

private:
	static void ConstructTimeString( WCHAR* szTime, bool fShowAllForCopyTime = false );
	static void CompileDisplayFormatString();
	static void updaterThread( void* );
	static void ToggleTitleBar();
	static void ToggleBorder();
	static void ToggleAlwaysOnTop();
	static void ToggleMaximized();
	static void CopyTime();
	static void PasteTime();
	static void PrintText( int nDisplayStringLength, int nShift, int nClientWidth );
	static INT_PTR CALLBACK WndProc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp );
	static INT_PTR CALLBACK CustomEditorWndProc( HWND hWnd, UINT uMsg, WPARAM wp, LPARAM lp );
	static INT_PTR CALLBACK TextPosEditorWndProc( HWND hWnd, UINT uMsg, WPARAM wp, LPARAM lp );
};
