//  This file is part of foo_timedisplay.
//
//  foo_timedisplay is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  foo_timedisplay is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with foo_timedisplay. If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include "foobar2000.h"

class foo_timedisplay_callback : public play_callback
{
public:
	foo_timedisplay_callback();
	~foo_timedisplay_callback();

	void CalculateTime( double p_time );
	void EnableMsecTimer();
	void DisableMsecTimer();

private:
	// this process is called every 1ms
	static void CALLBACK msecTimerProc(UINT uTimerID, UINT uMsg, DWORD_PTR dwUser, DWORD_PTR dw1, DWORD_PTR dw2);

	bool foo_timedisplay_callback::playlist_enum_callback(t_size p_index, const metadb_handle_ptr &p_location, bool b_selected);
	void on_playback_time( double p_time );
	void on_playback_seek( double p_time );
	void on_playback_stop( play_control::t_stop_reason p_reason );
	void on_playback_new_track( metadb_handle_ptr p_track );
	void on_playback_pause( bool p_state );
	void on_playback_dynamic_info( const file_info & p_info );

	// we're not using these callbacks
	void on_playback_starting( playback_control::t_track_command p_command, bool p_paused ) {};
	void on_playback_edited( metadb_handle_ptr p_track ) {}
	void on_playback_dynamic_info_track( const file_info & p_info ) {}
	void on_volume_change( float p_new_val ) {}
};
