//  This file is part of foo_timedisplay.
//
//  foo_timedisplay is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  foo_timedisplay is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with foo_timedisplay. If not, see <http://www.gnu.org/licenses/>.

#include "foo_timedisplay_callback_playlist.h"
#include "foo_timedisplay.h"

extern foo_timedisplay* g_foo_timedisplay;

foo_timedisplay_callback_playlist g_foo_timedisplay_callback_playlist;

foo_timedisplay_callback_playlist::foo_timedisplay_callback_playlist(void)
{
}

foo_timedisplay_callback_playlist::~foo_timedisplay_callback_playlist(void)
{
}

void foo_timedisplay_callback_playlist::on_items_added(t_size p_playlist, t_size p_start, const pfc::list_base_const_t< metadb_handle_ptr > &p_data, const bit_array &p_selection) {
	g_foo_timedisplay->updateRemainingPlaylistLength();
}

void foo_timedisplay_callback_playlist::on_items_reordered(t_size p_playlist, const t_size *p_order, t_size p_count) {
	g_foo_timedisplay->updateRemainingPlaylistLength();
}

void foo_timedisplay_callback_playlist::on_items_removing(t_size p_playlist, const bit_array &p_mask, t_size p_old_count, t_size p_new_count) {}

void foo_timedisplay_callback_playlist::on_items_removed(t_size p_playlist, const bit_array &p_mask, t_size p_old_count, t_size p_new_count) {
	g_foo_timedisplay->updateRemainingPlaylistLength();
}

void foo_timedisplay_callback_playlist::on_items_selection_change(t_size p_playlist, const bit_array &p_affected, const bit_array &p_state) {}
void foo_timedisplay_callback_playlist::on_item_focus_change(t_size p_playlist, t_size p_from, t_size p_to) {}

void foo_timedisplay_callback_playlist::on_items_modified(t_size p_playlist, const bit_array &p_mask) {
	g_foo_timedisplay->updateRemainingPlaylistLength();
}

void foo_timedisplay_callback_playlist::on_items_modified_fromplayback(t_size p_playlist, const bit_array &p_mask, play_control::t_display_level p_level) {
	g_foo_timedisplay->updateRemainingPlaylistLength();
}

void foo_timedisplay_callback_playlist::on_items_replaced(t_size p_playlist, const bit_array &p_mask, const pfc::list_base_const_t< t_on_items_replaced_entry > &p_data) {
	g_foo_timedisplay->updateRemainingPlaylistLength();
}

void foo_timedisplay_callback_playlist::on_item_ensure_visible(t_size p_playlist, t_size p_idx) {}
void foo_timedisplay_callback_playlist::on_playlist_activate(t_size p_old, t_size p_new) {}
void foo_timedisplay_callback_playlist::on_playlist_created(t_size p_index, const char *p_name, t_size p_name_len) {}
void foo_timedisplay_callback_playlist::on_playlists_reorder(const t_size *p_order, t_size p_count) {}
void foo_timedisplay_callback_playlist::on_playlists_removing(const bit_array &p_mask, t_size p_old_count, t_size p_new_count) {}
void foo_timedisplay_callback_playlist::on_playlists_removed(const bit_array &p_mask, t_size p_old_count, t_size p_new_count) {}
void foo_timedisplay_callback_playlist::on_playlist_renamed(t_size p_index, const char *p_new_name, t_size p_new_name_len) {}
void foo_timedisplay_callback_playlist::on_default_format_changed() {}
void foo_timedisplay_callback_playlist::on_playlist_locked(t_size p_playlist, bool p_locked) {}

void foo_timedisplay_callback_playlist::on_playback_order_changed(t_size p_new_index) {
	g_foo_timedisplay->updateRemainingPlaylistLength();
}
