//  This file is part of foo_timedisplay.
//
//  foo_timedisplay is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  foo_timedisplay is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with foo_timedisplay. If not, see <http://www.gnu.org/licenses/>.

#include "foo_timedisplay_callback_playlist_enum_items.h"

foo_timedisplay_callback_playlist_enum_items::foo_timedisplay_callback_playlist_enum_items(void)
{
	static_api_ptr_t<playlist_manager> pPlaylistManager;
	t_size nCurrPlaylist;

	pPlaylistManager->get_playing_item_location(&nCurrPlaylist, &nCurrentlyPlayingItemIndex);
	dRemainingPlaylistLength = 0;
}

foo_timedisplay_callback_playlist_enum_items::~foo_timedisplay_callback_playlist_enum_items(void)
{
}

double foo_timedisplay_callback_playlist_enum_items::getRemainingPlaylistLength(void) {
	return dRemainingPlaylistLength;
}

bool foo_timedisplay_callback_playlist_enum_items::on_item(t_size p_index, const metadb_handle_ptr &p_location, bool b_selected) {
	file_info_impl file_info;

	if (p_index > nCurrentlyPlayingItemIndex) { // Only calculating file lengths after the currently playing playlist item.
		p_location->get_info(file_info);
		dRemainingPlaylistLength += file_info.get_length();
	}
	return 1;
}
