//  This file is part of foo_timedisplay.
//
//  foo_timedisplay is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  foo_timedisplay is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with foo_timedisplay. If not, see <http://www.gnu.org/licenses/>.

#include <windows.h>

#include "helper.h"

LPSTR UnicodeToAnsi( LPCWSTR s )
{
	if ( s == NULL ) return NULL;
	int cw = lstrlenW( s );
	if ( cw == 0 ) { CHAR *psz = new CHAR[1]; *psz = '\0'; return psz; }
	int cc = WideCharToMultiByte( CP_ACP, 0, s, cw, NULL, 0, NULL, NULL );
	if ( cc == 0 ) return NULL;
	CHAR *psz = new CHAR[cc+1];
	cc = WideCharToMultiByte( CP_UTF8, 0, s, cw, psz, cc, NULL, NULL );
	if ( cc==0 ) { delete[] psz; return NULL; }
	psz[cc] = '\0';
	return psz;
}

WCHAR* AnsiToUnicode( const char* src )
{
	const size_t newsize = MultiByteToWideChar( CP_ACP, 0, src, -1, 0, 0 );
	WCHAR* newstring = new WCHAR[newsize];
	MultiByteToWideChar( CP_UTF8, 0, src, -1, newstring, newsize );
	return newstring;
}
